"use strict";

exports.__esModule = true;
exports.default = exports.Anchor = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactRouterDom = require("react-router-dom");
var _withStyles = require("../helpers/withStyles");
var _reactWithStyles = require("react-with-styles");
var _excluded = ["block", "children", "disabled", "external", "href", "loading", "openInNewWindow", "css", "target", "theme", "styles", "noHoverUnderline"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var propTypes = _extends({}, _reactWithStyles.withStylesPropTypes, {
  block: _propTypes.default.bool,
  disabled: _propTypes.default.bool,
  external: _propTypes.default.bool,
  href: _propTypes.default.string,
  loading: _propTypes.default.bool,
  openInNewWindow: _propTypes.default.bool,
  target: _propTypes.default.string,
  noHoverUnderline: _propTypes.default.bool
});
var Anchor = function Anchor(_ref) {
  var block = _ref.block,
    children = _ref.children,
    disabled = _ref.disabled,
    external = _ref.external,
    href = _ref.href,
    loading = _ref.loading,
    openInNewWindow = _ref.openInNewWindow,
    css = _ref.css,
    target = _ref.target,
    theme = _ref.theme,
    styles = _ref.styles,
    noHoverUnderline = _ref.noHoverUnderline,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  return !external && href ? /*#__PURE__*/_react.default.createElement(_reactRouterDom.Link, _extends({}, props, css(styles.anchor, !noHoverUnderline && styles.anchor_underlined), {
    to: href,
    disabled: disabled,
    target: openInNewWindow ? '_blank' : '_self'
  }), children) : /*#__PURE__*/_react.default.createElement("a", _extends({}, props, css(styles.anchor, !noHoverUnderline && styles.anchor_underlined), {
    href: href,
    target: target
  }), children);
};
Anchor.propTypes = propTypes;
var AnchorWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color;
  return {
    anchor: {
      color: color.secondary,
      cursor: 'pointer',
      textDecoration: 'none'
    },
    anchor_underlined: {
      ':hover': {
        textDecoration: 'underline'
      }
    }
  };
})(Anchor);
exports.Anchor = AnchorWithStyles;
var _default = AnchorWithStyles;
exports.default = _default;