"use strict";

exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _withStyles = require("../helpers/withStyles");
var _Spacing = _interopRequireDefault(require("./Spacing"));
var _Text = _interopRequireDefault(require("./Text"));
var _Title = _interopRequireDefault(require("./Title"));
var _Icon = _interopRequireDefault(require("./Icon"));
var _reactWithStyles = require("react-with-styles");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var propTypes = _extends({}, _reactWithStyles.withStylesPropTypes, {
  after: _propTypes.default.object,
  before: _propTypes.default.object,
  children: _propTypes.default.any.isRequired,
  description: _propTypes.default.string,
  done: _propTypes.default.bool,
  errorMessage: _propTypes.default.string,
  invalid: _propTypes.default.bool,
  title: _propTypes.default.string
});
var ConfigurationItem = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ConfigurationItem, _Component);
  function ConfigurationItem() {
    return _Component.apply(this, arguments) || this;
  }
  var _proto = ConfigurationItem.prototype;
  _proto.render = function render() {
    var _this$props = this.props,
      after = _this$props.after,
      before = _this$props.before,
      children = _this$props.children,
      css = _this$props.css,
      description = _this$props.description,
      done = _this$props.done,
      errorMessage = _this$props.errorMessage,
      invalid = _this$props.invalid,
      styles = _this$props.styles,
      title = _this$props.title;
    return /*#__PURE__*/_react.default.createElement("div", css(styles.configurationItem), before, /*#__PURE__*/_react.default.createElement("div", css(styles.configurationItem__content), /*#__PURE__*/_react.default.createElement(_Spacing.default, {
      bottom: 1
    }, /*#__PURE__*/_react.default.createElement(_Title.default, {
      noSpacing: true,
      light: true,
      level: 3
    }, title, (done || invalid) && /*#__PURE__*/_react.default.createElement("div", css(styles.statusLabel, done && styles.statusLabel_done, invalid && styles.statusLabel_error), /*#__PURE__*/_react.default.createElement(_Icon.default, {
      micro: true,
      inverse: true,
      name: done ? 'check' : 'error'
    }))), /*#__PURE__*/_react.default.createElement(_Text.default, {
      small: true,
      mutted: true
    }, description)), children, invalid && errorMessage && /*#__PURE__*/_react.default.createElement("div", css(styles.errorMessage), /*#__PURE__*/_react.default.createElement(_Text.default, {
      error: true
    }, "Mensagem de erro"))), after);
  };
  return ConfigurationItem;
}(_react.Component);
var ConfigurationItemWithStyles = (0, _withStyles.withStyles)(function (_ref) {
  var color = _ref.color,
    units = _ref.units,
    radius = _ref.radius,
    font = _ref.font;
  return {
    configurationItem: {
      borderRadius: radius,
      borderWidth: 1,
      borderColor: color.blueGrayLight,
      borderStyle: 'solid',
      background: color.white,
      overflow: 'hidden'
    },
    configurationItem__content: {
      padding: units(1.5)
    },
    statusLabel: {
      width: 16,
      height: 16,
      marginLeft: 8,
      borderRadius: '50%',
      display: 'inline-flex',
      alignItems: 'center',
      justifyContent: 'center'
    },
    statusLabel_done: {
      background: color.success
    },
    statusLabel_error: {
      background: color.alert
    },
    statusLabel__icon: {
      fill: color.white
    },
    errorMessage: {
      background: color.alertLight,
      marginTop: units(1.5),
      marginRight: units(-1.5),
      marginBottom: units(-1.5),
      marginLeft: units(-1.5),
      paddingTop: units(1),
      paddingRight: units(1.5),
      paddingBottom: units(1),
      paddingLeft: units(1.5)
    }
  };
})(ConfigurationItem);
ConfigurationItem.propTypes = propTypes;
var _default = ConfigurationItemWithStyles;
exports.default = _default;