"use strict";

exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _withStyles = require("../helpers/withStyles");
var _reactWithStyles = require("react-with-styles");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var propTypes = _extends({}, _reactWithStyles.withStylesPropTypes, {
  children: _propTypes.default.any,
  htmlFor: _propTypes.default.string,
  inline: _propTypes.default.bool,
  table: _propTypes.default.bool
});
var Label = function Label(_ref) {
  var children = _ref.children,
    css = _ref.css,
    htmlFor = _ref.htmlFor,
    inline = _ref.inline,
    styles = _ref.styles,
    table = _ref.table;
  return /*#__PURE__*/_react.default.createElement("label", _extends({}, css(styles.label, inline && styles.label_inline, table && styles.label_table), {
    htmlFor: htmlFor
  }), table ? /*#__PURE__*/_react.default.createElement("div", css(styles.label__tableRow), children) : children);
};
Label.propTypes = propTypes;
var LabelWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var units = _ref2.units,
    color = _ref2.color;
  return {
    label: {
      backgroundColor: color.transparent,
      border: 0,
      cursor: 'pointer',
      display: 'block',
      padding: 0
    },
    label_inline: {
      display: 'inline-block',
      whiteSpace: 'nowrap'
    },
    label_table: {
      display: 'table'
    },
    label__tableRow: {
      display: 'table-row'
    }
  };
})(Label);
var _default = LabelWithStyles;
exports.default = _default;