"use strict";

exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _withStyles = require("../helpers/withStyles");
var _reactWithStyles = require("react-with-styles");
var _Blanket = _interopRequireDefault(require("./Blanket"));
var _FlatButton = _interopRequireDefault(require("./FlatButton"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var propTypes = _extends({}, _reactWithStyles.withStylesPropTypes, {
  children: _propTypes.default.any.isRequired,
  flex: _propTypes.default.bool,
  fullHeight: _propTypes.default.bool,
  fullScreen: _propTypes.default.bool,
  global: _propTypes.default.bool,
  large: _propTypes.default.bool,
  medium: _propTypes.default.bool,
  centralize: _propTypes.default.bool,
  micro: _propTypes.default.bool,
  noPadding: _propTypes.default.bool,
  onClickBlanket: _propTypes.default.func,
  onClose: _propTypes.default.func,
  removeBlanket: _propTypes.default.bool,
  removeCloseButton: _propTypes.default.bool,
  small: _propTypes.default.bool,
  visible: _propTypes.default.bool,
  xlarge: _propTypes.default.bool,
  zIndex: _propTypes.default.number
});
var Modal = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Modal, _Component);
  function Modal() {
    return _Component.apply(this, arguments) || this;
  }
  var _proto = Modal.prototype;
  _proto.render = function render() {
    var _this$props = this.props,
      css = _this$props.css,
      children = _this$props.children,
      flex = _this$props.flex,
      fullHeight = _this$props.fullHeight,
      fullScreen = _this$props.fullScreen,
      global = _this$props.global,
      large = _this$props.large,
      medium = _this$props.medium,
      centralize = _this$props.centralize,
      micro = _this$props.micro,
      noPadding = _this$props.noPadding,
      onClickBlanket = _this$props.onClickBlanket,
      onClose = _this$props.onClose,
      removeBlanket = _this$props.removeBlanket,
      removeCloseButton = _this$props.removeCloseButton,
      small = _this$props.small,
      styles = _this$props.styles,
      visible = _this$props.visible,
      xlarge = _this$props.xlarge,
      zIndex = _this$props.zIndex;
    return visible ? /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement("div", css(centralize && styles.modal_centralize, styles.container, {
      zIndex: typeof zIndex === 'number' && zIndex
    }), /*#__PURE__*/_react.default.createElement("div", css(styles.modal, flex && styles.modal_flex, fullHeight && styles.modal_fullHeight, !fullScreen && !xlarge && !small && !large && !medium && !micro && styles.modal_default, fullScreen && styles.modal_fullScreen, micro && styles.modal_micro, small && styles.modal_small, large && styles.modal_large, medium && styles.modal_medium, xlarge && styles.modal_xlarge, noPadding && styles.noPadding), !removeCloseButton && /*#__PURE__*/_react.default.createElement("div", css(styles.closeButton), /*#__PURE__*/_react.default.createElement(_FlatButton.default, {
      transparent: true,
      icon: "error",
      onClick: function onClick() {
        return onClose && onClose();
      }
    })), children), (removeBlanket || !fullScreen) && /*#__PURE__*/_react.default.createElement(_Blanket.default, {
      global: global,
      visible: true,
      onClick: function onClick() {
        return onClickBlanket ? onClickBlanket() : onClose ? onClose() : null;
      }
    }))) : null;
  };
  return Modal;
}(_react.Component);
var ModalWithStyles = (0, _withStyles.withStyles)(function (_ref) {
  var _modal_fullHeight;
  var breakpoint = _ref.breakpoint,
    color = _ref.color,
    units = _ref.units,
    radius = _ref.radius,
    shadow = _ref.shadow;
  return {
    container: {
      position: 'absolute',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      padding: 0,
      margin: 0,
      height: '100vh',
      width: '100vw',
      overflow: 'auto',
      boxSizing: 'border-box'
    },
    modal: _extends({
      position: 'absolute',
      zIndex: 999,
      background: color.white,
      left: '50%',
      boxSizing: 'border-box',
      transform: 'translate(-50%, 0)',
      width: "calc(100% - " + units(2) + "px)",
      borderRadius: radius,
      borderColor: color.gray,
      borderWidth: 1,
      borderStyle: 'solid',
      padding: units(1.5),
      marginTop: units(1.5)
    }, shadow.level2),
    modal_centralize: {
      display: 'flex',
      alignItems: 'center'
    },
    modal_default: {
      maxWidth: units(30)
    },
    modal_medium: {
      maxWidth: units(40)
    },
    modal_flex: {
      display: 'flex',
      flexDirection: 'column'
    },
    modal_micro: {
      maxWidth: units(18)
    },
    modal_small: {
      maxWidth: units(24)
    },
    modal_large: {
      maxWidth: units(64)
    },
    modal_xlarge: {
      maxWidth: units(96)
    },
    modal_fullScreen: {
      width: 'unset',
      margin: 0,
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      transform: 'unset',
      borderRadius: 0,
      border: 0
    },
    modal_fullHeight: (_modal_fullHeight = {
      minHeight: "calc(100% - " + units(3) + "px)"
    }, _modal_fullHeight[breakpoint.large] = {
      maxHeight: "calc(100% - " + units(3) + "px)"
    }, _modal_fullHeight),
    closeButton: {
      position: 'absolute',
      top: units(.5),
      right: units(.5)
    },
    noPadding: {
      padding: 0
    }
  };
})(Modal);
Modal.propTypes = propTypes;
var _default = ModalWithStyles;
exports.default = _default;