"use strict";

exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Label = _interopRequireDefault(require("./Label"));
var _RadioButtonOnly = _interopRequireDefault(require("./RadioButtonOnly"));
var _Text = _interopRequireDefault(require("./Text"));
var _withStyles = require("../helpers/withStyles");
var _reactWithStyles = require("react-with-styles");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var propTypes = _extends({}, _reactWithStyles.withStylesPropTypes, {
  checked: _propTypes.default.bool,
  disabled: _propTypes.default.bool,
  id: _propTypes.default.string,
  invalid: _propTypes.default.bool,
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  name: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  pullRight: _propTypes.default.bool,
  refForFocus: _propTypes.default.func,
  subtitle: _propTypes.default.string,
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object, _propTypes.default.number])
});
var defaultProps = {
  label: '',
  radioButton: false
};
var RadioButton = function RadioButton(_ref) {
  var checked = _ref.checked,
    css = _ref.css,
    disabled = _ref.disabled,
    id = _ref.id,
    invalid = _ref.invalid,
    label = _ref.label,
    name = _ref.name,
    onBlur = _ref.onBlur,
    onChange = _ref.onChange,
    onFocus = _ref.onFocus,
    pullRight = _ref.pullRight,
    refForFocus = _ref.refForFocus,
    styles = _ref.styles,
    subtitle = _ref.subtitle,
    value = _ref.value;
  return /*#__PURE__*/_react.default.createElement(_Label.default, {
    htmlFor: id
  }, /*#__PURE__*/_react.default.createElement("div", css(styles.column, pullRight && styles.pullRight), /*#__PURE__*/_react.default.createElement(_RadioButtonOnly.default, {
    id: id,
    checked: checked,
    disabled: disabled,
    invalid: invalid,
    name: name,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    value: value
  })), /*#__PURE__*/_react.default.createElement("div", css(styles.column, pullRight ? styles.marginRight : styles.spacing), /*#__PURE__*/_react.default.createElement("div", css(styles.radioButton__label), typeof label === 'string' ? /*#__PURE__*/_react.default.createElement(_Text.default, {
    disabled: disabled
  }, label) : label), subtitle && checked && /*#__PURE__*/_react.default.createElement("div", css(styles.subtitle), /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true
  }, subtitle))));
};
RadioButton.propTypes = propTypes;
RadioButton.defaultProps = defaultProps;
var RadioButtonWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var _radioButton__label;
  var units = _ref2.units,
    color = _ref2.color,
    font = _ref2.font,
    fontSize = _ref2.fontSize,
    weight = _ref2.weight,
    lineHeight = _ref2.lineHeight,
    breakpoint = _ref2.breakpoint;
  return {
    radioButton: {},
    column: {
      display: 'table-cell',
      verticalAlign: 'top',
      whiteSpace: 'normal'
    },
    radioButton__label: (_radioButton__label = {
      color: color.grayDarker,
      cursor: 'pointer',
      display: 'inline-block',
      wordWrap: 'break-word',
      letterSpacing: 'normal',
      fontFamily: font.default,
      fontWeight: weight.normal,
      fontSize: fontSize.small.regular,
      lineHeight: lineHeight.regular
    }, _radioButton__label[breakpoint.large] = {
      fontSize: fontSize.large.regular
    }, _radioButton__label),
    spacing: {
      paddingLeft: 12
    },
    marginRight: {
      marginRight: 32
    },
    pullRight: {
      float: 'right'
    },
    subtitle: {
      paddingTop: 2
    }
  };
})(RadioButton);
var _default = RadioButtonWithStyles;
exports.default = _default;