"use strict";

exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _lodash = _interopRequireDefault(require("lodash"));
var _moment = _interopRequireDefault(require("moment"));
var _ComboButton = _interopRequireDefault(require("./ComboButton"));
var _Text = _interopRequireDefault(require("./Text"));
var _Anchor = _interopRequireDefault(require("./Anchor"));
var _Spacing = _interopRequireDefault(require("./Spacing"));
var _StatusIndicator = _interopRequireDefault(require("./StatusIndicator"));
var _Grid = _interopRequireDefault(require("./Grid"));
var _Cell = _interopRequireDefault(require("./Cell"));
var _Responsive = require("./Responsive");
var _Visibility = _interopRequireDefault(require("./Visibility"));
var _CheckboxOnly = _interopRequireDefault(require("./CheckboxOnly"));
var _withStyles = require("../helpers/withStyles");
var _reactWithStyles = require("react-with-styles");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var propTypes = _extends({}, _reactWithStyles.withStylesPropTypes, {
  item: _propTypes.default.object,
  clean: _propTypes.default.bool,
  checked: _propTypes.default.bool,
  onChange: _propTypes.default.func,
  onAction: _propTypes.default.func,
  children: _propTypes.default.any,
  divided: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  selectable: _propTypes.default.bool,
  hideComboButton: _propTypes.default.bool
});
var defaultProps = {
  item: {}
};
var SummaryItem = /*#__PURE__*/function (_Component) {
  _inheritsLoose(SummaryItem, _Component);
  function SummaryItem(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _this.state = {
      hover: false
    };
    return _this;
  }
  var _proto = SummaryItem.prototype;
  _proto.render = function render() {
    var _this2 = this;
    var _this$props = this.props,
      item = _this$props.item,
      clean = _this$props.clean,
      checked = _this$props.checked,
      _onChange = _this$props.onChange,
      onAction = _this$props.onAction,
      children = _this$props.children,
      divided = _this$props.divided,
      loading = _this$props.loading,
      selectable = _this$props.selectable,
      styles = _this$props.styles,
      css = _this$props.css,
      hideComboButton = _this$props.hideComboButton;
    var hover = this.state.hover;
    return /*#__PURE__*/_react.default.createElement("li", _extends({}, css(styles.summaryItem, divided && styles.summaryItem_divided), {
      onMouseOver: function onMouseOver() {
        return _this2.setState({
          hover: true
        });
      },
      onMouseOut: function onMouseOut() {
        return _this2.setState({
          hover: false
        });
      }
    }), /*#__PURE__*/_react.default.createElement(_Grid.default, {
      resetSpacing: true
    }, /*#__PURE__*/_react.default.createElement(_Visibility.default, {
      showIf: selectable,
      unmount: true
    }, /*#__PURE__*/_react.default.createElement(_Responsive.Responsive, {
      showFor: "medium",
      unmount: true
    }, /*#__PURE__*/_react.default.createElement("div", css(styles.summaryItem__checkboxContainer, clean && styles.summaryItem__checkboxContainer_clean, clean && hover && styles.summaryItem__checkboxContainer_visible), /*#__PURE__*/_react.default.createElement(_Cell.default, {
      shrink: true,
      noSpacing: clean
    }, /*#__PURE__*/_react.default.createElement(_CheckboxOnly.default, {
      checked: checked,
      onChange: function onChange() {
        return _onChange();
      }
    }))))), children && /*#__PURE__*/_react.default.createElement(_Cell.default, {
      shrink: true
    }, children), /*#__PURE__*/_react.default.createElement(_Cell.default, {
      auto: true,
      noSpacing: true
    }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
      resetSpacing: true
    }, /*#__PURE__*/_react.default.createElement(_Cell.default, {
      auto: true,
      maxWidth: 24
    }, /*#__PURE__*/_react.default.createElement(_Text.default, {
      loading: loading,
      bold: true
    }, /*#__PURE__*/_react.default.createElement(_Anchor.default, {
      onClick: function onClick() {
        return onAction(item.clickAction ? item.clickAction : item.mainAction);
      }
    }, item.title)), /*#__PURE__*/_react.default.createElement(_Text.default, {
      small: true,
      shimmerWidth: "100%",
      loading: loading
    }, item.description), /*#__PURE__*/_react.default.createElement(_Text.default, {
      small: true,
      bold: true,
      loading: loading
    }, item.params && Array.isArray(item.params) && item.params.join(', ')), item.log && /*#__PURE__*/_react.default.createElement(_Spacing.default, {
      top: .5
    }, /*#__PURE__*/_react.default.createElement(_Text.default, {
      muted: true,
      small: true,
      shimmerWidth: "80%",
      loading: loading
    }, /*#__PURE__*/_react.default.createElement(_react.Fragment, null, _lodash.default.capitalize(item.log.action), /*#__PURE__*/_react.default.createElement("strong", null, item.log.datetime &&
    //moment(item.log.datetime).format('DD [de] MMMM [de] YYYY [às] hh:mm')
    _moment.default.utc(item.log.datetime).fromNow()), item.log.user && /*#__PURE__*/_react.default.createElement("span", null, " por ", item.log.link ? /*#__PURE__*/_react.default.createElement("strong", null, /*#__PURE__*/_react.default.createElement("a", {
      href: item.log.link
    }, item.log.user)) : /*#__PURE__*/_react.default.createElement("strong", null, item.log.user), " "))))), /*#__PURE__*/_react.default.createElement(_Cell.default, {
      noSpacing: true,
      size: 12,
      largeSize: 2
    }, item.status && /*#__PURE__*/_react.default.createElement(_Spacing.default, {
      top: 1,
      topLargeAndAbove: 0.1,
      left: 1,
      leftLargeAndAbove: 0.25
    }, /*#__PURE__*/_react.default.createElement(_StatusIndicator.default, {
      loading: loading,
      text: item.status.label,
      color: item.status.color
    }))), /*#__PURE__*/_react.default.createElement(_Cell.default, {
      size: 12,
      autoOnMedium: true,
      center: true
    }, item.report && Array.isArray(item.report) && item.report.length > 0 && /*#__PURE__*/_react.default.createElement(_Spacing.default, {
      top: 1.25,
      topLargeAndAbove: 0
    }, /*#__PURE__*/_react.default.createElement("div", css(styles.summaryItem__info), item.report.map(function (data) {
      if (data) {
        return /*#__PURE__*/_react.default.createElement("div", _extends({}, css(styles.summaryItem__info__item), {
          key: data.label
        }), /*#__PURE__*/_react.default.createElement("strong", css(styles.summaryItem__info__value), data.value, data.tooltip && /*#__PURE__*/_react.default.createElement("div", null, "oi")), /*#__PURE__*/_react.default.createElement("span", css(styles.summaryItem__info__label), data.label));
      } else {
        return false;
      }
    })))))), /*#__PURE__*/_react.default.createElement(_Cell.default, {
      size: 12,
      shrinkOnMedium: true
    }, /*#__PURE__*/_react.default.createElement("div", css(styles.summaryItem__actions, clean && styles.summaryItem__actions_clean, clean && hover && styles.summaryItem__actions_visible), item.customButton, !hideComboButton && /*#__PURE__*/_react.default.createElement(_ComboButton.default, {
      soft: true,
      loading: loading,
      shimmer: loading,
      mainOption: item.actions && item.actions.filter(function (action) {
        return item.mainAction === action.value;
      })[0],
      options: item.actions ? item.actions.filter(function (action) {
        return item.mainAction !== action.value;
      }) : [],
      onClick: function onClick(option) {
        return onAction && onAction(option);
      },
      closeOnSelect: true,
      noSpacing: true
    })))));
  };
  return SummaryItem;
}(_react.Component);
SummaryItem.propTypes = propTypes;
SummaryItem.defaultProps = defaultProps;
var SummaryItemWithStyles = (0, _withStyles.withStyles)(function (_ref) {
  var _summaryItem__checkbo, _summaryItem__checkbo2, _summaryItem__actions, _summaryItem__actions2, _summaryItem__actions3, _summaryItem__info__i, _summaryItem__info__v, _summaryItem__info__l;
  var color = _ref.color,
    units = _ref.units,
    breakpoint = _ref.breakpoint,
    gutter = _ref.gutter,
    fontSize = _ref.fontSize,
    font = _ref.font,
    weight = _ref.weight;
  return {
    summaryItem: {
      padding: 0,
      paddingTop: units(1.25),
      paddingBottom: units(1.25),
      position: 'relative',
      display: 'flex',
      fontFamily: font.default
    },
    summaryItem_divided: {
      borderBottomWidth: 1,
      borderBottomStyle: 'solid',
      borderBottomColor: color.blueGrayLight
    },
    summaryItem__checkboxContainer: {
      flexShrink: 1,
      flexGrow: 0
    },
    summaryItem__checkboxContainer_clean: (_summaryItem__checkbo = {
      position: 'absolute',
      paddingLeft: units(1),
      transform: 'translate(calc(-100% + .5rem), 0)',
      visibility: 'visible',
      height: '100%',
      transition: 'visibility .25s ,opacity .25s'
    }, _summaryItem__checkbo[breakpoint.large] = {
      visibility: 'hidden',
      opacity: 0.01
    }, _summaryItem__checkbo),
    summaryItem__checkboxContainer_visible: (_summaryItem__checkbo2 = {}, _summaryItem__checkbo2[breakpoint.large] = {
      visibility: 'visible',
      opacity: 1
    }, _summaryItem__checkbo2),
    summaryItem__actions: (_summaryItem__actions = {
      marginTop: units(1)
    }, _summaryItem__actions[breakpoint.mediumAndAbove] = {
      marginTop: 0
    }, _summaryItem__actions),
    summaryItem__actions_clean: (_summaryItem__actions2 = {
      visibility: 'visible',
      transition: 'visibility .25s ,opacity .25s'
    }, _summaryItem__actions2[breakpoint.large] = {
      visibility: 'hidden',
      opacity: 0.01
    }, _summaryItem__actions2),
    summaryItem__actions_visible: (_summaryItem__actions3 = {}, _summaryItem__actions3[breakpoint.large] = {
      visibility: 'visible',
      opacity: 1
    }, _summaryItem__actions3),
    summaryItem__content: {
      flex: 1
    },
    summaryItem__info: {
      display: 'flex'
    },
    summaryItem__info__item: (_summaryItem__info__i = {
      width: units(5),
      padding: units(.25),
      textAlign: 'left'
    }, _summaryItem__info__i[breakpoint.large] = {
      textAlign: 'center'
    }, _summaryItem__info__i),
    summaryItem__info__value: (_summaryItem__info__v = {
      fontSize: fontSize.small.large,
      fontWeight: weight.bold,
      color: color.primary,
      lineHeight: 1,
      display: 'block'
    }, _summaryItem__info__v[breakpoint.large] = {
      fontSize: fontSize.large.large
    }, _summaryItem__info__v),
    summaryItem__info__label: (_summaryItem__info__l = {
      fontSize: fontSize.small.small,
      color: color.grayDarker
    }, _summaryItem__info__l[breakpoint.large] = {
      fontSize: fontSize.large.small
    }, _summaryItem__info__l)
  };
})(SummaryItem);
var _default = SummaryItemWithStyles;
exports.default = _default;